stages:
  - build_jar
  - push_docker_images
  - deploy_k8s

build:
 stage: build_jar
 tags: 
    - rakesh
 script:
    - echo "BUILD_START"
    - mvn clean package
    - echo "BUILD_FINISHED"
 artifacts:
    when: on_success
    paths:
     - target/*.jar

docker_build:
 stage: push_docker_images
 tags:
    - rakesh
 before_script:
    - source .env
    - docker login -u "$DOCKER_USER" -p "$DOCKER_PASSWORD"
    - export TAG=$(git log -1 --date=format:%y%m%d --format=%cd)
    #- export IMAGE_TAG=$(git log -1 --date=format:'%y%m%d-' --format=%cd%h)
    - export HASH=$(git rev-parse HEAD | cut -c -8)
    - export IMAGE_TAG=("$TAG"-"$HASH")
 script:
    - docker build --tag "$CI_REGISTRY_IMAGE":"$TAG"-"$HASH" . --build-arg IMAGE_TAG="$TAG"-"$HASH"
    - docker tag "$CI_REGISTRY_IMAGE":"$TAG"-"$HASH" "$DOCKER_USERNAME"/initial:"$TAG"-"$HASH"
    - docker push "$DOCKER_USERNAME"/initial:"$TAG"-"$HASH"

k8s_build:
 stage: deploy_k8s
 #dependencies: []
 tags:
     - rakesh
 before_script:
    - source .env
    - export TAG=$(git log -1 --date=format:%y%m%d --format=%cd)
    - echo $TAG
    - export HASH=$(git rev-parse HEAD | cut -c -8)
    - echo $HASH
 script:
    -  kubectl describe ns $CI_COMMIT_REF_NAME || kubectl create ns $CI_COMMIT_REF_NAME
    -  kubectl describe ns $CI_COMMIT_REF_NAME || kubectl create secret tls assignment-tls --key $HOME/certs/k8s/k8s-demo.test.com.key --cert $HOME/certs/k8s/k8s-demo.test.com.crt -n $CI_COMMIT_REF_NAME 
    -  kubectl apply -f $HOME/devops-practices/k8s/config -n $CI_COMMIT_REF_NAME
    -  kubectl apply -f $HOME/devops-practices/k8s/secret -n $CI_COMMIT_REF_NAME
    -  kubectl apply -f $HOME/devops-practices/k8s/deployment/db -n $CI_COMMIT_REF_NAME
    #-  kubectl apply -f $HOME/devops-practices/k8s/deployment/app -n $CI_COMMIT_REF_NAME --IMAGE=$TAG-$HASH
    -  envsubst < $HOME/devops-practices/k8s/deployment/app/deployment.yaml | kubectl apply -f - --namespace=$CI_COMMIT_REF_NAME
    -  kubectl apply -f $HOME/devops-practices/k8s/deployment/app/service.yaml -n $CI_COMMIT_REF_NAME
    #-  kubectl apply -f $HOME/devops-practices/k8s/ingress -n $CI_COMMIT_REF_NAME

 tags:
     - rakesh
# cleanup:
#   stage: cleanup
#   script:
#     - kubectl delete namespace $CI_COMMIT_REF_NAME
#   tags:
#     - rakesh


# helm_build:
#  stage: deploy_helm
#  tags:
#       - rakesh
#  script:
#       -  kubectl describe ns $CI_COMMIT_REF_NAME || kubectl create ns $CI_COMMIT_REF_NAME
#       -  helm upgrade --install app $HOME/devops-practices/helm/app/ --set-file appsecret.tlscrt=$HOME/certs/helm/helm-demo.test.com.crt --set-file appsecret.tlskey=$HOME/certs/helm/helm-demo-test.com.key
#  tags:
#       - rakesh